unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, IniFiles, bmRegExp, ShellAPI;

type
  time_t = Longint;

  TFormMain = class(TForm)
    EditSrc: TEdit;
    ButtonSrc: TButton;
    EditDst: TEdit;
    ButtonDst: TButton;
    LabelSrc: TLabel;
    LabelDst: TLabel;
    RadioGroupType: TRadioGroup;
    ButtonExecute: TButton;
    ButtonClose: TButton;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    AWKStr1: TAWKStr;
    OpenDialog1: TOpenDialog;
    CheckBoxOpen: TCheckBox;
    LabelLog: TLabel;
    GroupBoxNif: TGroupBox;
    EditID: TEdit;
    LabelID: TLabel;
    LabelTotal: TLabel;
    EditTotal: TEdit;
    EditExt: TEdit;
    LabelExt: TLabel;
    CheckBoxAddress: TCheckBox;
    CheckBoxAdjustTitle: TCheckBox;
    EditEditor: TEdit;
    ButtonEditor: TButton;
    LabelEditor: TLabel;
    procedure ButtonExecuteClick(Sender: TObject);
    procedure ButtonSrcClick(Sender: TObject);
    procedure ButtonDstClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function HTMLDecode(S: String): String;
    procedure ApplicationMessage(var Msg: TMsg; var Handled:Boolean);
    procedure ButtonCloseClick(Sender: TObject);
    procedure RadioGroupTypeClick(Sender: TObject);
    function time_tToDateTime(Time: time_t): TDateTime;
    function DateTimeTotime_t(Time: TDateTime): time_t;
    procedure EditTotalEnter(Sender: TObject);
    procedure CheckBoxOpenClick(Sender: TObject);
    procedure ButtonEditorClick(Sender: TObject);
    procedure CheckBoxAddressClick(Sender: TObject);
    procedure EditEditorEnter(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormMain: TFormMain;

implementation

var
  TimeZoneInformation: TTimeZoneInformation;
  Bias: TDateTime;
const
  SecondPerDate = 24 * 60 * 60;
{$R *.DFM}

procedure TFormMain.ButtonExecuteClick(Sender: TObject);
var
  FileSrc, FileDst, S: String;
  StrNum, StrReply, StrName, StrTitle, StrMail, StrURL, StrDateTime, StrBody, StrPerlTime: String;
  LogList, StrList: TStringList;
  I, PrevNumber: Integer;
  MyDateTime: TDateTime;
const
  NifNameLength = 16;
  NifTitleLength = 40;
begin
  if MessageDlg('ϊJn܂H', mtConfirmation, mbOKCancel, 0)
    = mrCancel then
    Exit;

  PrevNumber := 0;

  FileSrc := EditSrc.Text;
  FileDst := EditDst.Text;
  if (FileSrc = '') or (FileDst = '') then
  begin
    MessageDlg(
      'ϊt@C܂͕ϊt@Cw肳Ă܂',
      mtError, [mbOK], 0);
    Exit;
  end;
  if FileSrc = FileDst then
  begin
    MessageDlg(
      'ϊt@Cƕϊt@Cł',
      mtError, [mbOK], 0);
    EditDst.SetFocus;
    Exit;
  end;
  if not FileExists(FileSrc) then
  begin
    MessageDlg(
      'ϊt@C݂܂',
      mtError, [mbOK], 0);
    EditSrc.SetFocus;
    Exit;
  end;

  Memo1.Clear;
  Memo1.Refresh;
  Memo1.Lines.Add('ϊ: ' + EditSrc.Text);
  Memo1.Lines.Add('ϊ: ' + EditDst.Text + #13#10);

  LogList := TStringList.Create;
  StrList := TStringList.Create;
  try
    LogList.LoadFromFile(FileSrc);
    AWKStr1.RegExp := '<>';
    if RadioGroupType.ItemIndex = 2 then
    begin
      for I := LogList.Count - 1 downto 0 do
      begin
        StatusBar1.SimpleText := IntToStr(I);
        S := LogList.Strings[I];
        if (AWKStr1.Split(S, StrList) > 15) and (StrToIntDef(StrList.Strings[0], 0) <> 0) then
        begin
          if CheckBoxAddress.Checked then
          begin
            LogList.Strings[I]
              := StrList.Strings[0] + '<>'
                + StrList.Strings[1] + '<>'
                + StrList.Strings[2] + '<>'
                + StrList.Strings[3] + '<>'
                + StrList.Strings[4] + '<>'
                + StrList.Strings[5] + '<>'
                + StrList.Strings[6] + '<>'
                + StrList.Strings[7] + '<>'
                + StrList.Strings[8] + '<>'
                + StrList.Strings[9] + '<>'
                + '' + '<>'
                + '' + '<>'
                + StrList.Strings[12] + '<>'
                + StrList.Strings[13] + '<>'
                + StrList.Strings[14] + '<>'
                + StrList.Strings[15] + '<>';
          end else
          begin
            LogList.Strings[I]
              := StrList.Strings[0] + '<>'
                + StrList.Strings[1] + '<>'
                + StrList.Strings[2] + '<>'
                + StrList.Strings[3] + '<>'
                + '' + '<>'
                + '' + '<>'
                + StrList.Strings[6] + '<>'
                + StrList.Strings[7] + '<>'
                + StrList.Strings[8] + '<>'
                + StrList.Strings[9] + '<>'
                + '' + '<>'
                + '' + '<>'
                + StrList.Strings[12] + '<>'
                + StrList.Strings[13] + '<>'
                + StrList.Strings[14] + '<>'
                + StrList.Strings[15] + '<>';
          end;
        end;
      end;
    end else
    begin
      for I := LogList.Count - 1 downto 0 do
      begin
        StatusBar1.SimpleText := IntToStr(I);
        S := LogList.Strings[I];
        if (AWKStr1.Split(S, StrList) > 15) and (StrToIntDef(StrList.Strings[0], 0) <> 0) then
        begin
          StrList.Strings[0] := Format('%.5d', [StrToInt(StrList.Strings[0])]);
          StrList.Strings[1] := Format('%.5d', [StrToIntDef(StrList.Strings[1], 0)]);

          LogList.Strings[I]
            := StrList.Strings[0] + '<>'
              + StrList.Strings[1] + '<>'
              + StrList.Strings[2] + '<>'
              + StrList.Strings[3] + '<>'
              + StrList.Strings[4] + '<>'
              + StrList.Strings[5] + '<>'
              + StrList.Strings[6] + '<>'
              + StrList.Strings[7] + '<>'
              + StrList.Strings[8] + '<>'
              + StrList.Strings[9] + '<>'
              + StrList.Strings[10] + '<>'
              + StrList.Strings[11] + '<>'
              + StrList.Strings[12] + '<>'
              + StrList.Strings[13] + '<>'
              + StrList.Strings[14] + '<>'
              + StrList.Strings[15] + '<>';
        end else
        begin
          LogList.Delete(I)
        end;
      end;

      StatusBar1.SimpleText := '\[gĂ܂...';
      LogList.Sort;

      for I := 0 to LogList.Count - 1 do
      begin
        StatusBar1.SimpleText := IntToStr(I);
        S := LogList.Strings[I];
        AWKStr1.Split(S, StrList);
        //ԍ
        StrNum := StrList.Strings[0];
        //Rgԍ
        if StrToIntDef(StrList.Strings[1], 0) = 0 then
          StrReply := ''
        else
          StrReply := StrList.Strings[1];
        //薼
        StrTitle := HTMLDecode(StrList.Strings[3]);
        //e-mail
        StrMail := StrList.Strings[4];
        //URL
        StrURL := StrList.Strings[5];
        //O
        StrName := HTMLDecode(StrList.Strings[6]);
        //
        StrDateTime := StrList.Strings[7];
        //{
        StrBody := HTMLDecode(StrList.Strings[8]);
        //t_time
        StrPerlTime := StrList.Strings[9];

        MyDateTime := time_tToDateTime(StrToInt(StrPerlTime));

        /// Aԃ`FbN ///
        if I <> 0 then
        begin
          if StrToInt(StrNum)= PrevNumber then
          begin
            Memo1.Lines.Add(Format('  ԍ %s dĂ܂', [StrNum]));
          end;
          if StrToInt(StrNum) > PrevNumber + 1 then
          begin
            Memo1.Lines.Add(Format('  ԍ %.5d  %s ̊ԂĂ܂', [PrevNumber, StrNum]));
          end;
        end;
        PrevNumber := StrToInt(StrNum);
        ////////////////////

        Case RadioGroupType.ItemIndex of
        0:
          begin
            S := 'From: ' + StrName + #13#10
              + 'Subject: ' + StrTitle + #13#10
              + 'Date: ' + FormatDateTime('yyyy/mm/dd hh:nn:ss', MyDateTime) + #13#10
              + 'Message-ID: <' + StrNum + '>' + #13#10;
            if StrReply <> '' then
              S := S + 'References: <' + StrReply + '>' + #13#10;

            if CheckBoxAddress.Checked then
            begin
              if StrMail <> '' then
                S := S + Format('E-Mail: %s', [StrMail]) + #13#10;
              if StrURL <> '' then
                S := S + Format('URL: http://%s', [StrURL]) + #13#10;
            end;

            S := S
              + #13#10 + StrBody + #13#10;

            S := S + #13#10 + '.';
          end;
        1:
          begin
            if CheckBoxAdjustTitle.Checked then
            begin
              if Length(StrName) > NifNameLength then
              begin
                if ByteType(StrName, NifNameLength ) = mbTrailByte then
                  StrName := Copy(StrName, 1, NifNameLength - 1)
                else
                  StrName := Copy(StrName, 1, NifNameLength);
              end;
              if Length(StrTitle) > NifTitleLength then
              begin
                if ByteType(StrTitle, NifTitleLength - 1) = mbTrailbyte then
                  StrTitle := Copy(StrTitle, 1, NifTitleLength - 1)
                else
                  StrTitle := Copy(StrTitle, 1, NifTitleLength);
              end;
            end;

            if EditTotal.Text = '' then
              S := Format('%s/%s %-8s  %-16s %s', [StrNum, StrNum, EditID.Text, StrName, StrTitle]) + #13#10
                + FormatDateTime('( 1)   yy/mm/dd hh:nn', MyDateTime)
            else
              S := Format('%s/%.5d %-8s  %-16s %s', [StrNum, StrToIntDef(EditTotal.Text, 0), EditID.Text, StrName, StrTitle]) + #13#10
                + FormatDateTime('( 1)   yy/mm/dd hh:nn', MyDateTime);

            if StrReply <> '' then
              S := S + Format('  %sւ̃Rg', [StrReply]);
            S := S + #13#10#13#10 + StrBody + #13#10;

            if CheckBoxAddress.Checked then
            begin
              if (StrMail <> '') or (StrURL <> '') then
                S := S + #13#10#13#10;
              if StrMail <> '' then
                S := S + Format('  E-Mail: %s', [StrMail]) + #13#10;
              if StrURL <> '' then
                S := S + Format('  URL: http://%s', [StrURL]) + #13#10;
            end;

            S := S + #13#10 + #32#08;
          end;
        end;

        LogList.Strings[I] := S;
      end;
    end;

  finally
    LogList.SaveToFile(FileDst);
    StrList.Free;
    LogList.Free;
    StatusBar1.SimpleText := '';
    if CheckBoxOpen.Checked then
    begin
      if FileExists(EditEditor.Text) then
        WinExec(PChar(AnsiQuotedStr(EditEditor.Text, #34) + #32 + AnsiQuotedStr(EditDst.Text, #34)), SW_SHOW)
      else
        ShellExecute(Handle, 'open', PChar(EditDst.Text), nil, nil, SW_NORMAL);
    end;
    Memo1.Lines.Add(#13#10 + 'ϊI' + #13#10);
  end;
end;

procedure TFormMain.ButtonSrcClick(Sender: TObject);
begin
  if EditSrc.Text <> '' then
    OpenDialog1.InitialDir := ExtractFileDir(EditSrc.Text);

  if OpenDialog1.Execute then
  begin
    EditSrc.Text := OpenDialog1.FileName;
    if EditExt.Text <> '' then
      EditDst.Text := ChangeFileExt(EditSrc.Text, '.' + EditExt.Text);
  end;
end;

procedure TFormMain.ButtonDstClick(Sender: TObject);
begin
  if EditDst.Text <> '' then
    OpenDialog1.InitialDir := ExtractFileDir(EditDst.Text);

  if OpenDialog1.Execute then
  begin
    EditDst.Text := OpenDialog1.FileName;
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  IniFile: TMemIniFile;
begin
  DragAcceptFiles(EditSrc.Handle, True);
  DragAcceptFiles(EditDst.Handle, True);
  Application.OnMessage := ApplicationMessage;
  IniFile := TMemIniFile.Create(AnsiLowerCase(ChangeFileExt(ParamStr(0), '.ini')));
  try
    EditSrc.Text := IniFile.ReadString('Common', 'EditSrc', '');
    EditDst.Text := IniFile.ReadString('Common', 'EditDst', '');
    EditExt.Text := IniFile.ReadString('Common', 'EditExt', 'txt');
    EditID.Text := IniFile.ReadString('Common', 'EditID', 'NIF00123');
    EditTotal.Text := IniFile.ReadString('Common', 'EditTotal', '');
    EditEditor.Text := IniFile.ReadString('Common', 'Program', '');
    RadioGroupType.ItemIndex := IniFile.ReadInteger('Common', 'LogType', 0) mod RadioGroupType.Items.Count;
    CheckBoxOpen.Checked := IniFile.ReadBool('Common', 'OpenOutput', True);
    CheckBoxAddress.Checked := IniFile.ReadBool('Common', 'AddURL', True);
    CheckBoxAdjustTitle.Checked := IniFile.ReadBool('Common', 'AdjustTitle', False);
  finally
    IniFile.Free;
  end;

  //initializationŌvZĂǂ
  GetTimeZoneInformation(TimeZoneInformation);
  Bias := (365 * 70 + 19) - TimeZoneInformation.Bias / (60 * 24);
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TMemIniFile;
begin
  IniFile := TMemIniFile.Create(AnsiLowerCase(ChangeFileExt(ParamStr(0), '.ini')));
  try
    IniFile.WriteString('Common', 'EditSrc', EditSrc.Text);
    IniFile.WriteString('Common', 'EditDst', EditDst.Text);
    IniFile.WriteString('Common', 'EditExt', EditExt.Text);
    IniFile.WriteString('Common', 'EditID', EditID.Text);
    IniFile.WriteString('Common', 'EditTotal', EditTotal.Text);
    IniFile.WriteString('Common', 'Program', EditEditor.Text);
    IniFile.WriteInteger('Common', 'LogType', RadioGroupType.ItemIndex);
    IniFile.WriteBool('Common', 'OpenOutput', CheckBoxOpen.Checked);
    IniFile.WriteBool('Common', 'AddURL', CheckBoxAddress.Checked);
    IniFile.WriteBool('Common', 'AdjustTitle', CheckBoxAdjustTitle.Checked);
  finally
    IniFile.UpdateFile;
    IniFile.Free;
  end;
end;

function TFormMain.HTMLDecode(S: String): String;
begin
  S := StringReplace(S, '<br>', #13#10, [rfReplaceAll]);
  S := StringReplace(S, '&amp;', '&', [rfReplaceAll]);
  S := StringReplace(S, '&lt;', '<', [rfReplaceAll]);
  S := StringReplace(S, '&gt;', '>', [rfReplaceAll]);
  result := S;
end;

procedure TFormMain.ApplicationMessage(var Msg: TMsg; var Handled:
Boolean);
var
  FileName: array [0..256] of Char;
  EditArray: array [1..3] of TEdit;
  I: Integer;
begin
  EditArray[1] := EditSrc;
  EditArray[2] := EditDst;
  for i := 1 to 3 do begin
    if (Msg.message = WM_DROPFILES) and
       (Msg.hwnd = EditArray[i].Handle) then
    begin
      DragQueryFile(Msg.wParam, 0, FileName, SizeOf(FileName)-1);
      EditArray[i].Text := FileName;
      DragFinish(Msg.wParam);
      Handled := True;

      if (i = 1) and (EditExt.Text <> '') then
        EditDst.Text := ChangeFileExt(FileName, '.' + EditExt.Text);
      Exit;
    end;
  end;
end;

procedure TFormMain.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.RadioGroupTypeClick(Sender: TObject);
begin
  Case RadioGroupType.ItemIndex of
  0:
    begin
      GroupBoxNif.Enabled := False;
      CheckBoxAddress.Caption := '҂̃AhXt(&M)';
      StatusBar1.SimpleText := '';
    end;
  1:
    begin
      GroupBoxNif.Enabled := True;
      CheckBoxAddress.Caption := '҂̃AhXt(&M)';
      StatusBar1.SimpleText := '';
    end;
  2:
    begin
      CheckBoxAddressClick(Sender);
      GroupBoxNif.Enabled := False;
      CheckBoxAddress.Caption := '҂̃AhX͏Ȃ(&M)';
    end;
  end;
end;

/// t_time <-> TDateTime ϊ
/// NIFTY FDELPHI TvQlɂ܂
///   http://forum.nifty.com/fdelphi/samples/00298.html ///
function TFormMain.time_tToDateTime(Time: time_t): TDateTime;
begin
  Result := Time / SecondPerDate + Bias;
end;

function TFormMain.DateTimeTotime_t(Time: TDateTime): time_t;
begin
  Result := Round((Time - Bias) * SecondPerDate);
end;

procedure TFormMain.EditTotalEnter(Sender: TObject);
begin
  StatusBar1.SimpleText := '[]w肵ȂꍇAԍƓɂ܂';
end;

procedure TFormMain.CheckBoxOpenClick(Sender: TObject);
begin
  EditEditor.Enabled := CheckBoxOpen.Checked
end;

procedure TFormMain.ButtonEditorClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    EditEditor.Text := OpenDialog1.FileName;
end;

procedure TFormMain.CheckBoxAddressClick(Sender: TObject);
begin
  if RadioGroupType.ItemIndex = 2 then
  begin
    if CheckBoxAddress.Checked then
      StatusBar1.SimpleText := 'Ô܂܁ApX[hAhoAhX܂'
    else
      StatusBar1.SimpleText := 'Ô܂܁ApX[hAhoAhXA҂̃AhXiURL, E-Mailj܂';
  end;
end;

procedure TFormMain.EditEditorEnter(Sender: TObject);
begin
  StatusBar1.SimpleText := '[vO]w肵ȂꍇAWindows̊֘AtŃI[v܂';
end;

end.
